import { EventEmitter } from '../../stencil-public-runtime';
import { Action } from 'redux';
import { KonvaEventObject } from 'konva/types/Node';
import { EventContainer } from './event-container/event-container';
import { EventList } from './event-list/event-list';
import { DataState } from './event/data.state';
import { IKaiSchedulerConfig } from './kai-scheduler-config';
import { ISchedulerState } from './kai-scheduler.store';
import { ResourceTree, ResourceTreeEvents } from './resource-tree/resource-tree';
import { CommonState } from './shared/common.state';
import { SUPPORTED_LOCALES, TranslateService } from './shared/i18n/translate-service';
import { IKaiSchedulerShared } from './shared/kai-scheduler-shared';
import { IEvent } from './event/event.interface';
import { EventBox } from './event-container/event-box';
export interface ISaveData {
    modified: any[];
    allEvents: any[];
}
export declare class KaiScheduler implements IKaiSchedulerShared {
    btnSaveClick: EventEmitter;
    private canvas;
    common: CommonState.State;
    containerObserver: any;
    private _cursor;
    get cursor(): string;
    set cursor(value: string);
    private _dragModeBackup;
    private _dragSubModeBackup;
    el: HTMLElement;
    eventBoxDblClick: EventEmitter<{
        event: IEvent;
        eventBox: EventBox;
    }>;
    eventContainer: EventContainer;
    eventList: EventList;
    get events(): DataState.States;
    private _grab;
    private _height;
    get isPanning(): boolean;
    private _isAltDown;
    private _isShiftDown;
    private lastZoomPosX;
    private lastZoomDateMs;
    locale: SUPPORTED_LOCALES;
    private _mousePositionDateMs;
    get mousePositionDateMs(): number;
    private _msPerPx;
    get msPerPx(): number;
    set msPerPx(msPerPx: number);
    readonly: boolean;
    resourceTree: ResourceTree<ResourceTreeEvents>;
    private searchInput;
    selectedEvent: IEvent;
    private stateKeyEventListTable;
    private stateKeyEventListResizer;
    private stateKeyResourceTree;
    private stateKeyResourceTreeResizer;
    private stateKeyResourceTreeScrollerVertical;
    store: any;
    private timeline;
    tooltipShown: boolean;
    translateService: TranslateService;
    private _viewDate;
    get viewDate(): Date;
    set viewDate(viewDate: Date);
    private viewDateMs;
    visibleMinDateMs: number;
    visibleMaxDateMs: number;
    private _width;
    private zoomChart;
    private _zoomLevel;
    private get zoomLevel();
    private set zoomLevel(value);
    private readonly zoomMaxLevel;
    private zoomStep;
    constructor();
    private _animateToZoom;
    private cacheHorizontal;
    private cacheClearHorizontal;
    cancel(): Promise<any>;
    clearHistory(): Promise<any>;
    componentDidUnload(): void;
    dragEventBox(eventId: string, movementPx: number): Promise<DataState.actionTypes.DragEventBox>;
    dump(resourceId?: string): Promise<any>;
    dumpEvent(eventId?: string): Promise<any>;
    private emitBtnSaveClick;
    private emitEventBoxDblClick;
    focusToEvent(eventId: string): void;
    getAbsoluteLeft(): number;
    private getZoomVirtualLevelForMsPerPx;
    private initMousePanZoom;
    getStage(): Promise<any>;
    getState(): Promise<ISchedulerState>;
    getYForResource(resourceId: any): number;
    private initStore;
    load(config: IKaiSchedulerConfig): Promise<void>;
    private onBoxClick;
    private onStateChange;
    passWheelEvent(event: KonvaEventObject<WheelEvent>): void;
    private prepareCanvas;
    prepareContainerResizeObserver(): void;
    prepareEventContainer(): void;
    prepareEventList(): void;
    prepareKeyboard(): void;
    prepareSearch(): void;
    redo(): Promise<Action<any>>;
    private redoInternal;
    removeSelectedFromSchedule(): Promise<Action<any>>;
    private removeSelectedFromScheduleInternal;
    save(): Promise<ISaveData>;
    tooltipForStopShow(text: any, x: any, y: any): void;
    tooltipForStopHide(): void;
    undo(): Promise<Action<any>>;
    private undoInternal;
    zoomIn(): Promise<number>;
    zoomOut(): Promise<number>;
    private zoomSetInternal;
    forceDraw(): Promise<void>;
    testScroll(pos: any): Promise<any>;
}
